process.env.NODE_TLS_REJECT_UNAUTHORIZED = "0"; // ugly hack!

var request		= require('request');
var _			= require('underscore');
var apiRoot 	= 'https://api2.formide.com/';

var call = function(options, callback) {
	
	// create the options object with defaults
	options = _.extend({
		path			: '/',
		method			: 'GET',
		access_token	: lib.settings.accessToken,
		refresh_token	: lib.settings.refreshToken,
		json			: true
	}, options);
	
	// make the request
	request({
		method	: options.method,
		url		: apiRoot + options.path,
		json	: options.json,
		headers	: {
			'Authorization': 'Bearer ' + options.access_token
		}
	}, function(err, response, body) {
		if (err) return callback(err);
		if (response.statusCode == 401) {
			console.log('Access token expired');
/*
			request({
				method: 'POST',
				url: 'https://sdk.athom.com/auth/refresh',
				json: {
					'refresh_token': options.refresh_token
				}
			}, function(err, result, body) {
				console.log(body)
			});
*/
			return;
		}
		
		if (typeof callback == 'function') {
			callback(null, response, body);
		}
		
	});
};

module.exports.call = call;